/*
**	FastMacroPanel.c
**
**	Editing panel for fast! macros
**
**	Copyright  1990-1993 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_LIST,GAD_MACRO,GAD_CODE,
		GAD_TOP,GAD_UP,GAD_DOWN,GAD_END,
		GAD_NEW,GAD_REMOVE,GAD_LOAD,GAD_SAVE };

STATIC struct Gadget *
CreateAllGadgets(struct Gadget **GadgetArray,struct Gadget **GadgetList)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0,i;

	SZ_SizeSetup(Window -> WScreen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		WORD ButtonWidth,ListWidth,LeftOffset;

		LeftOffset = SZ_LeftOffsetDelta(MSG_FASTMACROPANEL_MACRO_LIST_GAD,MSG_FASTMACROPANEL_MACRO_TEXT_GAD);

		SZ_AddLeftOffset(LeftOffset);

		SZ_ResetMaxWidth();

		for(i = MSG_FASTMACROPANEL_TOP_GAD ; i <= MSG_FASTMACROPANEL_NEW_GAD ; i++)
			SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(i),0,NULL);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_REMOVE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_LOAD_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_SAVE_GAD),0,NULL);

		ButtonWidth = SZ_ResetMaxWidth();

		SZ_UpdateMaxWidth(STRING_KIND,NULL,30,NULL);
		SZ_UpdateMaxWidth(LISTVIEW_KIND,NULL,20,NULL);

		ListWidth = SZ_ResetMaxWidth();

		if(ListWidth + LeftOffset < 4 * ButtonWidth + 3 * InterWidth)
			ListWidth = 4 * ButtonWidth + 3 * InterWidth - LeftOffset;
		else
			ButtonWidth = (LeftOffset + ListWidth - 3 * InterWidth) / 4;

		SZ_SetWidth(ListWidth);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_MACRO_LIST_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_LEFT;

		GadgetArray[Counter++] = Gadget = CreateGadget(LISTVIEW_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,
			SZ_Lines,		10,
			SZ_InterHeight,		0,

			GTLV_Labels,		&FastMacroList,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_MACRO_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= NULL;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTST_MaxChars,	19,
			GA_Disabled,	TRUE,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_MACRO_TEXT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignBottom,	TRUE,

			GTST_MaxChars,	255,
			GA_Disabled,	TRUE,
			GA_Immediate,	TRUE,
		TAG_DONE);

		SZ_SetWidth(ButtonWidth);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_TOP_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,
			SZ_GroupCount,	4,

			GA_Disabled,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_UP_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,

			GA_Disabled,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_DOWN_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,

			GA_Disabled,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_END_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,

			GA_Disabled,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_FASTMACROPANEL_NEW_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignBottom,	TRUE,
			SZ_GroupCount,	4,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_REMOVE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,
			GA_Disabled,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_LOAD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SAVE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,
			GA_Disabled,	TRUE,
		TAG_DONE);
	}

	return(Gadget);
}

VOID
FastMacroPanel()
{
	struct Window		*PanelWindow;
	struct Gadget		*GadgetList = NULL;
	struct Gadget		*GadgetArray[GAD_SAVE + 1];
	UBYTE		 	 DummyBuffer[MAX_FILENAME_LENGTH],
				*DummyChar;
	struct FileRequester	*FileRequest;

	if(CreateAllGadgets(GadgetArray,&GadgetList))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	GetScreenLeft(Window) + (GetScreenWidth(Window) - SZ_GetWindowWidth()) / 2,
			WA_Top,		GetScreenTop(Window) + (GetScreenHeight(Window) - SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,		TRUE,
			WA_DragBar,		TRUE,
			WA_DepthGadget,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_CustomScreen,	Window -> WScreen,
			WA_NoCareRefresh,	TRUE,

			WA_IDCMP,		IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | IDCMP_RAWKEY | IDCMP_ACTIVEWINDOW | IDCMP_GADGETDOWN | LISTVIEWIDCMP | STRINGIDCMP | BUTTONIDCMP,

			WA_Title,		LocaleString(MSG_FASTMACROPANEL_FAST_MACRO_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 IClass,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;
			struct MacroNode	*Node,*Selected = NULL;
			ULONG			 Offset = 0;

			GuideContext(CONTEXT_FASTMACROS);

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			if(FastMacroList . lh_Head -> ln_Succ)
			{
				GT_SetGadgetAttrs(GadgetArray[GAD_SAVE],PanelWindow,NULL,
					GA_Disabled,	FALSE,
				TAG_DONE);
			}
			else
			{
				GT_SetGadgetAttrs(GadgetArray[GAD_SAVE],PanelWindow,NULL,
					GA_Disabled,	TRUE,
				TAG_DONE);
			}

			ActiveGadget = NULL;

			SetSignal(0,SIG_BREAK);

			while(!Terminated)
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
					break;

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					IClass	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					KeySelect(GadgetArray,GAD_SAVE,Code,PanelWindow,&Gadget,&IClass,&Code);

					if(IClass == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(IClass == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(IClass == IDCMP_CLOSEWINDOW)
						Terminated = TRUE;

					if(IClass == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_TOP:

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	~0,
								TAG_DONE);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);
								}

								Remove((struct Node *)Selected);

								AddHead(&FastMacroList,(struct Node *)Selected);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	&FastMacroList,
									TAG_DONE);
								}

								Offset = 0;

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	&FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
									GA_Disabled,	TRUE,
								TAG_DONE);

								GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
									GA_Disabled,	TRUE,
								TAG_DONE);

								if(Selected -> mn_Succ -> mn_Succ)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);
								}
								else
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);
								}

								FastMacrosChanged = TRUE;

								break;

							case GAD_UP:

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	~0,
								TAG_DONE);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);
								}

								Node = Selected -> mn_Pred -> mn_Pred;

								Remove((struct Node *)Selected);

								Insert(&FastMacroList,(struct Node *)Selected,(struct Node *)Node);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	&FastMacroList,
									TAG_DONE);
								}

								Offset--;

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	&FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								if(Selected -> mn_Pred -> mn_Pred)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);
								}
								else
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);
								}

								if(Selected -> mn_Succ -> mn_Succ)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);
								}
								else
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);
								}

								FastMacrosChanged = TRUE;

								break;

							case GAD_DOWN:

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	~0,
								TAG_DONE);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);
								}

								Node = Selected -> mn_Succ;

								Remove((struct Node *)Selected);

								Insert(&FastMacroList,(struct Node *)Selected,(struct Node *)Node);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	&FastMacroList,
									TAG_DONE);
								}

								Offset++;

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	&FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								if(Selected -> mn_Pred -> mn_Pred)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);
								}
								else
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);
								}

								if(Selected -> mn_Succ -> mn_Succ)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);
								}
								else
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);
								}

								FastMacrosChanged = TRUE;

								break;

							case GAD_END:

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	~0,
								TAG_DONE);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);
								}

								Remove((struct Node *)Selected);

								AddTail(&FastMacroList,(struct Node *)Selected);

								if(FastWindow)
								{
									GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
										GTLV_Labels,	&FastMacroList,
									TAG_DONE);
								}

								Offset = FastMacroCount - 1;

								GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
									GTLV_Labels,	&FastMacroList,
									GTLV_Selected,	Offset,
									GTLV_Top,	Offset,
								TAG_DONE);

								GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
									GA_Disabled,	TRUE,
								TAG_DONE);

								GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
									GA_Disabled,	TRUE,
								TAG_DONE);

								if(Selected -> mn_Pred -> mn_Pred)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);
								}
								else
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);
								}

								FastMacrosChanged = TRUE;

								break;

							case GAD_NEW:

								if(Node = NewFastMacro(LocaleString(MSG_FASTMACROPANEL_UNNAMED_TXT),""))
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	~0,
										TAG_DONE);
									}

									AddTail(&FastMacroList,(struct Node *)Node);

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	&FastMacroList,
										TAG_DONE);
									}

									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	&FastMacroList,
										GTLV_Selected,	FastMacroCount++,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_CODE],PanelWindow,NULL,
										GTST_String,	"",
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_MACRO],PanelWindow,NULL,
										GTST_String,	Node -> mn_Macro,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_REMOVE],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_SAVE],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									if(FastMacroCount > 1)
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
											GA_Disabled,	FALSE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
											GA_Disabled,	FALSE,
										TAG_DONE);
									}
									else
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);
									}

									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									Selected = Node;

									Offset = Code;

									ActivateGadget(GadgetArray[GAD_MACRO],PanelWindow,NULL);

									ActiveGadget = GadgetArray[GAD_MACRO];

									FastMacrosChanged = TRUE;
								}
								else
									DisplayBeep(Window -> WScreen);

								break;

							case GAD_REMOVE:

								if(Selected)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	~0,
										TAG_DONE);
									}

									if(--FastMacroCount)
									{
										if(Selected -> mn_Succ -> mn_Succ)
											Node = Selected -> mn_Succ;
										else
										{
											Node = Selected -> mn_Pred;

											Offset = 0;
										}
									}

									RemFastMacro(Selected);

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	&FastMacroList,
										TAG_DONE);
									}

									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	&FastMacroList,
										GTLV_Selected,	Node -> mn_Succ ? GetFastMacroOffset(Node) : ~0,
									TAG_DONE);

									if(FastMacroCount < 2)
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);
									}
									else
									{
										if(FastMacroCount)
										{
											if(!Node -> mn_Succ -> mn_Succ)
											{
												GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
													GA_Disabled,	TRUE,
												TAG_DONE);

												GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
													GA_Disabled,	TRUE,
												TAG_DONE);
											}
										}
									}

									if(!FastMacroCount)
									{
										Selected = NULL;

										GT_SetGadgetAttrs(GadgetArray[GAD_CODE],PanelWindow,NULL,
											GTST_String,	"",
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_MACRO],PanelWindow,NULL,
											GTST_String,	"",
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_REMOVE],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_SAVE],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										ActiveGadget = NULL;
									}
									else
									{
										Selected = Node;

										GT_SetGadgetAttrs(GadgetArray[GAD_CODE],PanelWindow,NULL,
											GTST_String,	Selected -> mn_Code,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_MACRO],PanelWindow,NULL,
											GTST_String,	Selected -> mn_Macro,
										TAG_DONE);
									}

									FastMacrosChanged = TRUE;
								}

								break;

							case GAD_LIST:

								if(Selected = GetFastMacro(Code))
								{
									Offset = Code;

									GT_SetGadgetAttrs(GadgetArray[GAD_MACRO],PanelWindow,NULL,
										GTST_String,	Selected -> mn_Macro,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_CODE],PanelWindow,NULL,
										GTST_String,	Selected -> mn_Code,
										GA_Disabled,	FALSE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_REMOVE],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);

									if(Selected -> mn_Pred -> mn_Pred)
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
											GA_Disabled,	FALSE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
											GA_Disabled,	FALSE,
										TAG_DONE);
									}
									else
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);
									}

									if(Selected -> mn_Succ -> mn_Succ)
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
											GA_Disabled,	FALSE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
											GA_Disabled,	FALSE,
										TAG_DONE);
									}
									else
									{
										GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);

										GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
											GA_Disabled,	TRUE,
										TAG_DONE);
									}
								}

								break;

							case GAD_MACRO:

								if(Selected)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	~0,
										TAG_DONE);
									}

									strcpy(Selected -> mn_Macro,SZ_GetString(Gadget));

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	&FastMacroList,
										TAG_DONE);
									}

									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	&FastMacroList,
										GTLV_Selected,	GetFastMacroOffset(Selected),
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_CODE],PanelWindow,NULL,
										GTST_String,	Selected -> mn_Code,
									TAG_DONE);

									FastMacrosChanged = TRUE;

									ActivateGadget(ActiveGadget = GadgetArray[GAD_CODE],PanelWindow,NULL);
								}

								break;

							case GAD_CODE:

								if(Selected)
								{
									strcpy(Selected -> mn_Code,SZ_GetString(Gadget));

									FastMacrosChanged = TRUE;
								}

								break;

							case GAD_LOAD:

								strcpy(DummyBuffer,LastFastMacros);

								DummyChar = PathPart(DummyBuffer);

								*DummyChar = 0;

								BlockWindow(PanelWindow);

								if(FileRequest = GetFile(LocaleString(MSG_FASTMACROPANEL_LOAD_FAST_MACRO_SETTINGS_TXT),DummyBuffer,FilePart(LastFastMacros),DummyBuffer,"#?.prefs",FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_LOAD_TXT)))
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	~0,
									TAG_DONE);

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	~0,
										TAG_DONE);
									}

									Selected = NULL;

									if(!LoadFastMacros(DummyBuffer))
										MyEasyRequest(Window,LocaleString(MSG_FASTMACROPANEL_COULD_NOT_LOAD_FAST_MACRO_SETTINGS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
									else
									{
										strcpy(Config -> FileConfig -> FastMacroFileName,DummyBuffer);

										strcpy(LastFastMacros,DummyBuffer);

										FastMacrosChanged = FALSE;
									}

									GT_SetGadgetAttrs(GadgetArray[GAD_LIST],PanelWindow,NULL,
										GTLV_Labels,	&FastMacroList,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_CODE],PanelWindow,NULL,
										GTST_String,	"",
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_MACRO],PanelWindow,NULL,
										GTST_String,	"",
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_REMOVE],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_TOP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_UP],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_DOWN],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									GT_SetGadgetAttrs(GadgetArray[GAD_END],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);

									ActiveGadget = NULL;

									if(FastWindow)
									{
										GT_SetGadgetAttrs(FastGadget,FastWindow,NULL,
											GTLV_Labels,	&FastMacroList,
										TAG_DONE);
									}
								}

								if(FastMacroList . lh_Head -> ln_Succ)
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_SAVE],PanelWindow,NULL,
										GA_Disabled,	FALSE,
									TAG_DONE);
								}
								else
								{
									GT_SetGadgetAttrs(GadgetArray[GAD_SAVE],PanelWindow,NULL,
										GA_Disabled,	TRUE,
									TAG_DONE);
								}

								ReleaseWindow(PanelWindow);

								break;

							case GAD_SAVE:

								strcpy(DummyBuffer,LastFastMacros);

								DummyChar = PathPart(DummyBuffer);

								*DummyChar = 0;

								BlockWindow(PanelWindow);

								if(FileRequest = GetFile(LocaleString(MSG_FASTMACROPANEL_SAVE_FAST_MACRO_SETTINGS_TXT),DummyBuffer,FilePart(LastFastMacros),DummyBuffer,"#?.prefs",TRUE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SAVE_TXT)))
								{
									if(!SaveFastMacros(DummyBuffer))
										MyEasyRequest(Window,LocaleString(MSG_FASTMACROPANEL_COULD_NOT_SAVE_FAST_MACRO_SETTINGS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
									else
									{
										strcpy(LastFastMacros,DummyBuffer);

										FastMacrosChanged = FALSE;
									}
								}

								ReleaseWindow(PanelWindow);

								break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);
}
